const oracledb = require('oracledb');
const fs = require('fs');

const statsFileName = "stats.txt";
const maxIters = 475000;

const dbConfig = {
  user: "nodejs",
  password: "dev",
  connectString: "localhost/DB19"
};

async function performIter() {
  const conn = await oracledb.getConnection(dbConfig);
  const cls = await conn.getDbObjectClass("ISSUE_28988");
  await conn.close();
}

async function run() {
  let numIters = 0;
  fs.writeFileSync(statsFileName, "Num Iters,RSS,Heap Total,Heap Used,Ext\n");
  while (numIters < maxIters) {
    numIters++;
    await performIter();
    if (numIters % 1000 == 0) {
      console.log("Processed", numIters, "iterations...");
      global.gc();
      const stats = process.memoryUsage();
      const text1 = `${numIters},${stats.rss},${stats.heapTotal},`;
      const text2 = `${stats.heapUsed},${stats.external}\n`;
      fs.appendFileSync(statsFileName, text1 + text2);
      const x = 1;
    }
  }
}

run()
